local addonName, vars = ...
local L = vars.L
SkinSound = vars
local addon = SkinSound
local settings

local debugEnabled = false -- for addon debugging

local defaults = {
  enabled = true,
  playfrequency = 5,
  sound = true,
  yell = true,
}

local function chatMsg(msg) 
     DEFAULT_CHAT_FRAME:AddMessage(addonName..": "..msg)
end
local function debug(msg) 
  if debugEnabled then
     chatMsg(msg)
  end
end

local soundfiles = {
  rub1   = 45,
  rub2   = 45,
  basket = 10,  
}
addon.soundtable = {}
addon.soundsum = 0
for name, prob in pairs(soundfiles) do
  table.insert(addon.soundtable, { 
       "Interface\\AddOns\\"..addonName.."\\sound\\"..name..".mp3", prob
    })
  addon.soundsum = addon.soundsum + prob
end

function addon:doSkin()
  if not settings or not settings.enabled then return end
  local now = GetTime()
  if now - (addon.lastplay or 0) < settings.playfrequency then
    return
  end
  addon.lastplay = now
  if settings.sound then
    local roll = math.random(addon.soundsum)
    local file
    for _,e in ipairs(addon.soundtable) do
      local f,p = unpack(e)
      roll = roll - p
      if roll <= 0 then
        file = f
        break
      end
    end
    PlaySoundFile(file, "Master")
  end
  if settings.yell then
    local msg = settings.msg or "It rubs the lotion on its skin!"
    SendChatMessage(msg,"YELL")
  end
end

local skinning = GetSpellInfo(74522)

local function frame_OnEvent(self,event,...)
 if event == "ADDON_LOADED" and select(1,...) == addonName then  
   if not SkinSoundSettings then
     SkinSoundSettings = {} 
   end
   settings = SkinSoundSettings
   for k,v in pairs(defaults) do
     if settings[k] == nil then
        settings[k] = v
     end
   end
 elseif event == "UNIT_SPELLCAST_START" then
   local unitID, spell, rank, lineID, spellID = ...
   if unitID == "player" and spell == skinning then
     addon:doSkin()
   end
 end
end

local frame = CreateFrame("Button", addonName.."HiddenFrame", UIParent)
frame:SetScript("OnEvent", frame_OnEvent)
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("UNIT_SPELLCAST_START")

SLASH_SKINSOUND1 = "/skinsound"
SlashCmdList["SKINSOUND"] = function(msg)
	local cmd = msg:lower()
	if cmd == "on" then
	  settings.enabled = true
	  chatMsg("Enabled.")
	elseif cmd == "off" then
	  settings.enabled = false
	  chatMsg("Disabled.")
	elseif cmd == "yell" or cmd == "sound" then
	  settings[cmd] = not settings[cmd]
	  chatMsg(cmd.." "..(settings[cmd] and "enabled." or "disabled."))
	else
	  chatMsg("Usage: "..SLASH_SKINSOUND1.." [ on | off | yell | sound ]")
	end
end

